Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 0e673013 2019-01-02 stsp # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 c3754a5b 2019-05-10 stsp name=$(getent passwd $USER | cut -d: -f5)
18 c3754a5b 2019-05-10 stsp export GOT_AUTHOR="$name <$(whoami)@$(hostname)>"
19 c3754a5b 2019-05-10 stsp
20 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
21 7b67836a 2019-05-10 stsp
22 0e673013 2019-01-02 stsp function git_init
23 0e673013 2019-01-02 stsp {
24 0e673013 2019-01-02 stsp git init -q "$@"
25 0e673013 2019-01-02 stsp }
26 0e673013 2019-01-02 stsp
27 0e673013 2019-01-02 stsp function git_commit
28 0e673013 2019-01-02 stsp {
29 0e673013 2019-01-02 stsp local repo="$1"
30 0e673013 2019-01-02 stsp shift
31 0e673013 2019-01-02 stsp (cd $repo && git commit -q -a "$@")
32 0e673013 2019-01-02 stsp }
33 0e673013 2019-01-02 stsp
34 512f0d0e 2019-01-02 stsp function git_rm
35 512f0d0e 2019-01-02 stsp {
36 512f0d0e 2019-01-02 stsp local repo="$1"
37 512f0d0e 2019-01-02 stsp shift
38 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
39 512f0d0e 2019-01-02 stsp }
40 512f0d0e 2019-01-02 stsp
41 9c4b8182 2019-01-02 stsp function git_show_head
42 9c4b8182 2019-01-02 stsp {
43 9c4b8182 2019-01-02 stsp local repo="$1"
44 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
45 9c4b8182 2019-01-02 stsp }
46 9c4b8182 2019-01-02 stsp
47 818c7501 2019-07-11 stsp function git_show_parent_commit
48 818c7501 2019-07-11 stsp {
49 818c7501 2019-07-11 stsp local repo="$1"
50 818c7501 2019-07-11 stsp (cd $repo && git show --no-patch --pretty='format:%P')
51 818c7501 2019-07-11 stsp }
52 818c7501 2019-07-11 stsp
53 03415a1a 2019-06-02 stsp function git_show_tree
54 03415a1a 2019-06-02 stsp {
55 03415a1a 2019-06-02 stsp local repo="$1"
56 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
57 03415a1a 2019-06-02 stsp }
58 03415a1a 2019-06-02 stsp
59 818c7501 2019-07-11 stsp function trim_obj_id
60 818c7501 2019-07-11 stsp {
61 818c7501 2019-07-11 stsp let trimcount=$1
62 818c7501 2019-07-11 stsp id=$2
63 818c7501 2019-07-11 stsp
64 818c7501 2019-07-11 stsp pat=""
65 818c7501 2019-07-11 stsp while [ trimcount -gt 0 ]; do
66 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
67 818c7501 2019-07-11 stsp let trimcount--
68 818c7501 2019-07-11 stsp done
69 818c7501 2019-07-11 stsp
70 818c7501 2019-07-11 stsp echo ${id%$pat}
71 818c7501 2019-07-11 stsp }
72 818c7501 2019-07-11 stsp
73 03415a1a 2019-06-02 stsp function git_commit_tree
74 03415a1a 2019-06-02 stsp {
75 03415a1a 2019-06-02 stsp local repo="$1"
76 03415a1a 2019-06-02 stsp local msg="$2"
77 03415a1a 2019-06-02 stsp local tree="$3"
78 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
79 03415a1a 2019-06-02 stsp }
80 03415a1a 2019-06-02 stsp
81 0e673013 2019-01-02 stsp function make_test_tree
82 0e673013 2019-01-02 stsp {
83 0e673013 2019-01-02 stsp repo="$1"
84 0e673013 2019-01-02 stsp
85 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
86 0e673013 2019-01-02 stsp echo beta > $repo/beta
87 0e673013 2019-01-02 stsp mkdir $repo/gamma
88 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
89 0e673013 2019-01-02 stsp mkdir $repo/epsilon
90 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
91 0e673013 2019-01-02 stsp }
92 0e673013 2019-01-02 stsp
93 3ce1b845 2019-07-15 stsp function get_blob_id
94 3ce1b845 2019-07-15 stsp {
95 3ce1b845 2019-07-15 stsp repo="$1"
96 3ce1b845 2019-07-15 stsp tree_path="$2"
97 3ce1b845 2019-07-15 stsp filename="$3"
98 3ce1b845 2019-07-15 stsp
99 3ce1b845 2019-07-15 stsp got tree -r $repo -i $tree_path | grep ${filename}$ | cut -d' ' -f 1
100 3ce1b845 2019-07-15 stsp }
101 3ce1b845 2019-07-15 stsp
102 0e673013 2019-01-02 stsp function test_init
103 0e673013 2019-01-02 stsp {
104 0e673013 2019-01-02 stsp local testname="$1"
105 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
106 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
107 0e673013 2019-01-02 stsp echo "No test name provided" >&2
108 0e673013 2019-01-02 stsp return 1
109 0e673013 2019-01-02 stsp fi
110 0e673013 2019-01-02 stsp local testroot=`mktemp -p /tmp -d got-test-$testname-XXXXXXXX`
111 0e673013 2019-01-02 stsp mkdir $testroot/repo
112 0e673013 2019-01-02 stsp git_init $testroot/repo
113 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
114 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
115 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
116 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
117 4a1ddfc2 2019-01-12 stsp fi
118 0e673013 2019-01-02 stsp echo "$testroot"
119 0e673013 2019-01-02 stsp }
120 0e673013 2019-01-02 stsp
121 0e673013 2019-01-02 stsp function test_cleanup
122 0e673013 2019-01-02 stsp {
123 0e673013 2019-01-02 stsp local testroot="$1"
124 fe7842f5 2019-07-14 stsp
125 fe7842f5 2019-07-14 stsp (cd $testroot/repo && git fsck --strict \
126 fe7842f5 2019-07-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
127 fe7842f5 2019-07-14 stsp ret="$?"
128 fe7842f5 2019-07-14 stsp if [ "$ret" != "0" ]; then
129 fe7842f5 2019-07-14 stsp echo -n "git fsck: "
130 fe7842f5 2019-07-14 stsp cat $testroot/fsck.stderr
131 fe7842f5 2019-07-14 stsp echo "git fsck failed; leaving test data in $testroot"
132 fe7842f5 2019-07-14 stsp return 1
133 fe7842f5 2019-07-14 stsp fi
134 fe7842f5 2019-07-14 stsp
135 0e673013 2019-01-02 stsp rm -rf "$testroot"
136 0e673013 2019-01-02 stsp }
137 0e673013 2019-01-02 stsp
138 0e673013 2019-01-02 stsp function run_test
139 0e673013 2019-01-02 stsp {
140 0e673013 2019-01-02 stsp testfunc="$1"
141 370629d7 2019-01-02 stsp echo -n "$testfunc "
142 0e673013 2019-01-02 stsp $testfunc
143 0e673013 2019-01-02 stsp }
144 0e673013 2019-01-02 stsp
145 0e673013 2019-01-02 stsp function test_done
146 0e673013 2019-01-02 stsp {
147 0e673013 2019-01-02 stsp local testroot="$1"
148 0e673013 2019-01-02 stsp local result="$2"
149 0e673013 2019-01-02 stsp if [ "$result" == "0" ]; then
150 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
151 370629d7 2019-01-02 stsp echo "ok"
152 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
153 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
154 3941b73a 2019-05-14 stsp echo "$result"
155 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
156 0e673013 2019-01-02 stsp else
157 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
158 0e673013 2019-01-02 stsp fi
159 0e673013 2019-01-02 stsp }